import peasy.*;
PeasyCam cam;

int startYear = 2020;

PShape seattle;


Table table;
Table table1;
Table table2;
Table table3;
int numRows, numColumns;

ArrayList<AcBook> books = new ArrayList<AcBook>();
ArrayList<AcBook> books_all = new ArrayList<AcBook>();
ArrayList<AcBook> books_covid = new ArrayList<AcBook>();
ArrayList<BookFlow> bookflows = new ArrayList<BookFlow>();

void setup(){
  size(1300, 1300, P3D);
  smooth(); 
  cam = new PeasyCam(this, 200);
  
  float  cameraZ = (height/2.0) / tan(PI*60.0/360.0);
  perspective(PI/3.0, width/height, 0.001, cameraZ*10.0); //set near clip to 0.001 to go inside data

  
  seattle = loadShape("Map.svg");
  
  table = loadTable("acbk_health_2020_v2.csv", "header");
  table1 = loadTable("health_date_num.csv", "header");
  table2=loadTable("acbk_2020_v3.csv","header");
  table3=loadTable("covid_2020.csv","header");
  numRows = table.getRowCount();
  //println("Rows: " + numRows);
  
  for(int i=0; i<numRows; i++){
    String id= table.getString(i,0);
    String itemNum = table.getString(i,1);
    String date = table.getString(i,2);
    float deweyClass = table.getFloat(i,3);
    String rank = table.getString(i,4);
    books.add(new AcBook(id, itemNum, date, deweyClass, rank));
  }
  numRows = table2.getRowCount();
    for(int i=0; i<numRows; i++){
    String id= table2.getString(i,0);
    String itemNum = table2.getString(i,1);
    String date = table2.getString(i,2);
    float deweyClass = table2.getFloat(i,3);
    String rank = table2.getString(i,4);
    books_all.add(new AcBook(id, itemNum, date, deweyClass, rank));
  }
    numRows = table3.getRowCount();
    for(int i=0; i<numRows; i++){
    String id= table3.getString(i,0);
    String itemNum = table3.getString(i,1);
    String date = table3.getString(i,2);
    float deweyClass = table3.getFloat(i,3);
    String rank = table3.getString(i,4);
    books_covid.add(new AcBook(id, itemNum, date, deweyClass, rank));
  }
  
  for(int i=0; i<table1.getRowCount(); i++){
    String date = table1.getString(i,0);
    int bookNum = table1.getInt(i,1);
    bookflows.add(new BookFlow(date, bookNum));

  }  
}

void draw(){
  background(0);

  randomSeed(0);
    float dateAxis =0;
    float yAxis=0;
    float zAxis=0;
    color c= #000000;
  if(slection_2){
  for(int i=0; i<books.size(); i++){
        
    dateAxis = map(dateParser(books.get(i).date), 0, 363, -50, 50);
    // try to get the index locate of the time
  //  int temp_nums =100;
  //  for(int j=0; j<bookflows.size(); j++){
  //      //println(dateParser2(bookflows.get(j).date));
  //      //println(bookflows.get(i).date);
  //    if(dateParser2(bookflows.get(j).date) == dateParser(books.get(i).date)){
  //      println("ssssss");
  //      temp_nums = bookflows.get(j).bookNum;
  //    }
  //}  
    yAxis = map(random(books.size()), 0, books.size(), -50, 50);
    //println(temp_nums);
    zAxis = map(random(books.size()), 0, books.size(), -15, 15);
    c = covidRankDetermine(books.get(i).rank);

    
    pushMatrix();
    translate(dateAxis, yAxis, zAxis);
    strokeWeight(2);
    stroke(c);
    point(0,0,0);
    popMatrix();
  }
  }

if(slection_3){
    for(int i=0; i<books_all.size(); i++){
        
    dateAxis = map(dateParser(books_all.get(i).date), 0, 363, -50, 50);
    yAxis = map(random(books_all.size()), 0, books_all.size(), -50, 50);
    //println(temp_nums);
    zAxis = map(random(books_all.size()), 0, books_all.size(), -50, -20);
    c = covidRankDetermine(books_all.get(i).rank);

    
    pushMatrix();
    translate(dateAxis, yAxis, zAxis);
    strokeWeight(2);
    stroke(c);
    point(0,0,0);
    popMatrix();

  }

   }
   if(slection_1){

    for(int i=0; i<books_covid.size(); i++){
        
    dateAxis = map(dateParser(books_covid.get(i).date), 0, 363, -50, 50);
    //println(dateParser(books_covid.get(i).date));
    yAxis = map(random(books_covid.size()), 0, books_covid.size(), -50, 50);
    //println(temp_nums);
    zAxis = map(random(books_covid.size()), 0, books_covid.size(), 20, 50);
    c = covidRankDetermine(books_covid.get(i).rank);

    
    pushMatrix();
    translate(dateAxis, yAxis, zAxis);
    strokeWeight(2);
    stroke(c);
    point(0,0,0);
    popMatrix();

  }

   }

  

  pushMatrix();
  
  seattle.disableStyle();
  stroke(255);
  //rotateY(PI/2);
  translate(-50,0,0);
  rotateY(PI/2);
  shapeMode(CENTER);
  shape(seattle, -30, -20, 80, 80); 
  
  popMatrix();

  pushMatrix();
  
  seattle.disableStyle();
  stroke(255);
  //rotateY(PI/2);
  translate(50,0,0);
  rotateY(PI/2);
  shapeMode(CENTER);
  shape(seattle, -30, -20, 80, 80); 
  
  popMatrix();

  drawLabels();  
  fill(200, 20);
  stroke(255);
  box(100);
}
